/**
 *
 * @author
 *
 */
var Over = (function (_super) {
    __extends(Over, _super);
    function Over() {
        _super.call(this);
        this.skinName = "resource/skins/OverSkin.exml";
        this.visible = false;
        this.btn_shop.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_shop, this);
        //this.btn_rank.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_rank, this);
        //this.btn_star.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_star, this);
        this.btn_home.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_home, this);
        //this.btn_watckad.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_watckad, this);
        this.gp_cost.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_cost, this);
        this.btn_tofrist.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_tofrist, this);
        // TypeScript 代码
        var selfthat = this;
        egret.ExternalInterface.addCallback("showAdComplete", function (message) {
            selfthat.replay();
        });
    }
    var d = __define,c=Over,p=c.prototype;
    Over.getInstance = function () {
        if (Over.instance == null) {
            Over.instance = new Over();
        }
        return Over.instance;
    };
    p.updateStageHeight = function () {
        //console.log(this.stage.stageWidth + "," + this.stage.stageHeight);
        this.gp_buttons.y = this.stage.stageHeight - (260);
    };
    p.onclick_shop = function () {
        Shop.getInstance().Show(this.parent);
    };
    p.handleOver = function () {
        this.updateStageHeight();
        this.visible = true;
        this.alpha = 0;
        egret.Tween.get(this).wait(2000).call(Sound.getInstance().Play_Over, Sound.getInstance()).to({ "alpha": 1 }, 1000);
        this.lb_cost.text = DataManager.getInstance().CostPlay.toString();
        this.lb_mid_level.text = DataManager.getInstance().Milestone.toString();
        if (DataManager.getInstance().Milestone > DataManager.getInstance().bestLevel) {
            DataManager.getInstance().bestLevel = DataManager.getInstance().Milestone;
            this.img_best.visible = true;
            Sound.getInstance().Play_New();
        }
        else {
            this.img_best.visible = false;
        }
        DataManager.getInstance().OverSum += 1;
        if (DataManager.getInstance().OverSum > 3) {
            egret.Tween.get(this.btn_shop, { "loop": true })
                .wait(1000)
                .to({ "anchorOffsetY": 30 }, 1000)
                .to({ "anchorOffsetY": 0 }, 1000);
        }
        else {
            egret.Tween.get(this.gp_cost, { "loop": true })
                .wait(1000)
                .to({ "anchorOffsetY": 30 }, 1000)
                .to({ "anchorOffsetY": 0 }, 1000);
        }
    };
    p.onclick_star = function () {
        Sound.getInstance().Play_Button();
        alert("点击了星星，代码在：Over.ts");
    };
    p.onclick_rank = function () {
        Sound.getInstance().Play_Button();
        alert("点击了排行榜，代码在：Over.ts");
    };
    p.onclick_home = function () {
        Sound.getInstance().Play_Button();
        this.parent.parent.addChild(Begin.getInstance());
        Game.getInstance().parent.removeChild(Game.getInstance());
        this.close();
    };
    p.onclick_tofrist = function () {
        Dialog.getInstance().ShowGo1(this.parent, "3");
        egret.ExternalInterface.call("showAd", "53");
        return;
        Sound.getInstance().Play_Button();
        DataManager.getInstance().Milestone = 1;
        this.replay();
    };
    p.onclick_watckad = function () {
        Sound.getInstance().Play_Button();
        //alert("点击了看视频重玩，代码在：Over.ts");
        //如果成功了请调用replay()
//        egret.ExternalInterface.call("showAd", "54");
    };
    p.onclick_cost = function () {
        Sound.getInstance().Play_Button();
        //花费重玩
        if (DataManager.getInstance().Milestone >= 2) {
            if (DataManager.getInstance().Gold - DataManager.getInstance().CostPlay >= 0) {
                this.replay();
                DataManager.getInstance().Gold -= DataManager.getInstance().CostPlay;
            }
            else {
                Dialog.getInstance().ShowNeedMore(this.parent, "2");
            }
        }
        else {
            this.replay();
        }
    };
    p.replay = function () {
        Game.getInstance().beginGame();
        this.close();
    };
    p.close = function () {
        this.visible = false;
        if (this.parent != null) {
            this.parent.removeChild(this);
        }
        this.gp_cost.anchorOffsetY = 0;
        this.btn_shop.anchorOffsetY = 0;
        egret.Tween.removeTweens(this.gp_cost);
        egret.Tween.removeTweens(this.btn_shop);
    };
    Over.instance = null;
    return Over;
}(eui.Component));
egret.registerClass(Over,'Over');
