/**
 *
 * 商店内的商品管理
 *
 */
var emShopGoods;
(function (emShopGoods) {
    emShopGoods[emShopGoods["Ball1"] = 0] = "Ball1";
    emShopGoods[emShopGoods["Ball2"] = 1] = "Ball2";
    emShopGoods[emShopGoods["Ball3"] = 2] = "Ball3";
    emShopGoods[emShopGoods["Ball4"] = 3] = "Ball4";
    emShopGoods[emShopGoods["Ball5"] = 4] = "Ball5";
    emShopGoods[emShopGoods["Ball6"] = 5] = "Ball6";
    emShopGoods[emShopGoods["Ball7"] = 6] = "Ball7";
    emShopGoods[emShopGoods["Ball8"] = 7] = "Ball8";
    emShopGoods[emShopGoods["Ball9"] = 8] = "Ball9";
    emShopGoods[emShopGoods["Ball10"] = 9] = "Ball10";
    emShopGoods[emShopGoods["Ball11"] = 10] = "Ball11";
    emShopGoods[emShopGoods["Ball12"] = 11] = "Ball12";
    emShopGoods[emShopGoods["Miao2"] = 101] = "Miao2";
    emShopGoods[emShopGoods["Miao3"] = 102] = "Miao3";
})(emShopGoods || (emShopGoods = {}));
var ShopGoods = (function (_super) {
    __extends(ShopGoods, _super);
    function ShopGoods() {
        _super.call(this);
        this.cost_miao2 = 1000;
        this.cost_miao3 = 10000;
        //所有球的价格
        this.cost_balls = [0, 50, 100, 200, 300, 500, 1000, 2000, 3000, 4000, 5000, 6000];
        this.costLines = [100, 200, 500, 1000, 5000, 10000, 20000, 30000, 40000];
    }
    var d = __define,c=ShopGoods,p=c.prototype;
    p.createChildren = function () {
        _super.prototype.createChildren.call(this);
        //this.btn_gold1_buy.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_buy_gold1, this);
        //this.btn_gold2_buy.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_buy_gold2, this);
        //this.btn_gold3_buy.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_buy_gold3, this);
        this.img_line.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_buyline, this);
        //this.btn_miao3_buy.addEventListener(egret.TouchEvent.TOUCH_TAP,this.onclick_buy_miao3,this);
        for (var i = 0; i < 12; i++) {
            var btn = this.btn_balls_buy.getChildAt(i);
            btn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_buy_ball, this);
        }
        this.updateBuyState();
    };
    p.onclick_buy_gold1 = function () {
        Sound.getInstance().Play_Button();
        alert("点击了购买金币1，代码在：ShopGoods.ts");
        //购买金币成功后刷新 DataManager.getInstance().Gold;
    };
    p.onclick_buy_gold2 = function () {
        Sound.getInstance().Play_Button();
        alert("点击了购买金币2，代码在：ShopGoods.ts");
    };
    p.onclick_buy_gold3 = function () {
        Sound.getInstance().Play_Button();
        alert("点击了购买金币3，代码在：ShopGoods.ts");
    };
    p.onclick_buy_ball = function (e) {
        Sound.getInstance().Play_Button();
        var btn = e.currentTarget;
        var index = this.btn_balls_buy.getChildIndex(btn);
        if (btn.Had) {
            DataManager.getInstance().CurrentBall = index;
            this.updateBuyState();
        }
        else {
            //alert("点击了购买球，ID为" + index+"，代码在：ShopGoods.ts");
            //购买完成后使用DataManager.getInstance().addGoods添加一个商品
            //全部完成后，调用本类里的updateBuyState()刷新按钮状态
            var cost = this.cost_balls[index];
            if (DataManager.getInstance().Gold - cost < 0) {
                alert("钱不够");
            }
            else {
                DataManager.getInstance().CurrentBall = index;
                DataManager.getInstance().Gold -= cost;
                DataManager.getInstance().addGoods(index);
                egret.Tween.get(this)
                    .wait(100)
                    .call(this.updateBuyState, this);
            }
        }
    };
    p.onclick_buyline = function () {
        if (DataManager.getInstance().addLine >= 9) {
            return;
        }
        var cost = this.costLines[DataManager.getInstance().addLine];
        if (DataManager.getInstance().Gold - cost < 0) {
            alert("钱不够");
        }
        else {
            DataManager.getInstance().Gold -= cost;
            DataManager.getInstance().addLine += 1;
            this.updateBuyState();
        }
    };
    /*
    private onclick_buy_miao2(){
        Sound.getInstance().Play_Button();
        if(DataManager.getInstance().Gold - this.cost_miao2 <0){
            alert("钱不够");
        }else{
            DataManager.getInstance().Gold -= this.cost_miao2;
            DataManager.getInstance().addGoods(emShopGoods.Miao2);
            this.updateBuyState();
        }
        
    }
    private onclick_buy_miao3() {
        Sound.getInstance().Play_Button();
        if(DataManager.getInstance().addLine ==0){
            alert("请先购买瞄准线2");
            return;
        }
        if(DataManager.getInstance().Gold - this.cost_miao3< 0) {
            alert("钱不够");
        } else {
            DataManager.getInstance().Gold -= this.cost_miao3;
            DataManager.getInstance().addGoods(emShopGoods.Miao3);
            this.updateBuyState();
        }
    }*/
    p.updateBuyState = function () {
        var store = DataManager.getInstance().ShopStore;
        for (var i = 0; i < 12; i++) {
            var em = i;
            if (store.indexOf(em) >= 0) {
                var btn = this.btn_balls_buy.getChildAt(i);
                btn.Had = true;
                if (i == DataManager.getInstance().CurrentBall) {
                    btn.enabled = false;
                }
                else {
                    btn.enabled = true;
                }
            }
        }
        var index = DataManager.getInstance().addLine + 2;
        if (index > 10) {
            this.img_line.source = RES.getRes("line_max_png");
        }
        else {
            this.img_line.source = RES.getRes("line_" + index + "_png");
        }
        /*
        if(store.indexOf(emShopGoods.Miao2) >=0){
            this.btn_miao2_buy.enabled = false;
            DataManager.getInstance().addLine = 1;
        }
        if(store.indexOf(emShopGoods.Miao3) >= 0) {
            this.btn_miao3_buy.enabled = false;
            DataManager.getInstance().addLine = 2;
        }*/
    };
    return ShopGoods;
}(eui.Component));
egret.registerClass(ShopGoods,'ShopGoods');
