var egs;
(function (egs) {
    var scripts;
    (function (scripts) {
        var LookAtScript = (function (_super) {
            __extends(LookAtScript, _super);
            function LookAtScript(viewWidth, viewHeight, target) {
                _super.call(this);
                this.Target = null;
                this.viewWidth = 0;
                this.viewHeight = 0;
                this.Target = target;
                this.viewWidth = viewWidth;
                this.viewHeight = viewHeight;
            }
            var d = __define,c=LookAtScript,p=c.prototype;
            p.onUpdate = function () {
                var owner = this.Owner;
                if (owner == null) {
                    return;
                }
                var x = this.Target.x - this.viewWidth / 2;
                var y = this.Target.y - this.viewHeight / 2;
                if (x < 0)
                    x = 0;
                if (y < 0)
                    y = 0;
                if (x > owner.width - this.viewWidth)
                    x = owner.width - this.viewWidth;
                if (y > owner.height - this.viewHeight)
                    y = owner.height - this.viewHeight;
                owner.x = -(x);
                owner.y = -(y);
            };
            return LookAtScript;
        }(egs.Behaviour));
        scripts.LookAtScript = LookAtScript;
        egret.registerClass(LookAtScript,'egs.scripts.LookAtScript');
    })(scripts = egs.scripts || (egs.scripts = {}));
})(egs || (egs = {}));
