var egs;
(function (egs) {
    var scripts;
    (function (scripts) {
        var ZSortScript = (function (_super) {
            __extends(ZSortScript, _super);
            function ZSortScript() {
                _super.apply(this, arguments);
            }
            var d = __define,c=ZSortScript,p=c.prototype;
            p.onUpdate = function () {
                var group = this.Owner;
                if (group == null) {
                    return;
                }
                var list = [];
                for (var i = 0; i < group.numChildren; i++) {
                    list.push(group.getChildAt(i));
                }
                list.sort(ZSortScript._sort);
                for (var i = 0; i < list.length; i++) {
                    var obj = list[i];
                    group.setChildIndex(obj, i);
                }
            };
            ZSortScript._sort = function (n1, n2) {
                if (n1.y > n2.y) {
                    return 1;
                }
                if (n1.y < n2.y) {
                    return -1;
                }
                return 0;
            };
            return ZSortScript;
        }(egs.Behaviour));
        scripts.ZSortScript = ZSortScript;
        egret.registerClass(ZSortScript,'egs.scripts.ZSortScript');
    })(scripts = egs.scripts || (egs.scripts = {}));
})(egs || (egs = {}));
