var egs;
(function (egs) {
    var Dictionary = (function () {
        function Dictionary() {
            this._keys = [];
            this._values = [];
        }
        var d = __define,c=Dictionary,p=c.prototype;
        p.add = function (key, value) {
            this[key] = value;
            this._keys.push(key);
            this._values.push(value);
        };
        p.get = function (key) {
            if (this.containsKey(key)) {
                return this[key];
            }
            return null;
        };
        p.remove = function (key) {
            var index = this._keys.indexOf(key, 0);
            this._keys.splice(index, 1);
            this._values.splice(index, 1);
            delete this[key];
        };
        p.keys = function () {
            return this._keys;
        };
        p.values = function () {
            return this._values;
        };
        p.containsKey = function (key) {
            if (typeof this[key] === "undefined") {
                return false;
            }
            return true;
        };
        return Dictionary;
    }());
    egs.Dictionary = Dictionary;
    egret.registerClass(Dictionary,'egs.Dictionary');
})(egs || (egs = {}));
