var egs;
(function (egs) {
    var scripts;
    (function (scripts) {
        var RangingTargetScript = (function (_super) {
            __extends(RangingTargetScript, _super);
            function RangingTargetScript(target) {
                if (target === void 0) { target = null; }
                _super.call(this);
                this._target = null;
                this.Distance = 0;
                this.Angle = 0;
                this.Target = target;
            }
            var d = __define,c=RangingTargetScript,p=c.prototype;
            d(p, "Target"
                ,function () {
                    return this._target;
                }
                ,function (value) {
                    this._target = value;
                    this.rang();
                }
            );
            p.onUpdate = function (dt) {
                this.rang();
            };
            p.rang = function () {
                var obj = this.Owner;
                if (obj != null && this.Target != null) {
                    var tx = this.Target.x - obj.x;
                    var ty = this.Target.y - obj.y;
                    var pt = new egret.Point(tx, ty);
                    pt.normalize(1);
                    this.Vector = pt;
                    this.Angle = Math.atan2(ty, tx) * 180 / Math.PI + 180;
                    this.Distance = egret.Point.distance(new egret.Point(obj.x, obj.y), new egret.Point(this.Target.x, this.Target.y));
                }
            };
            return RangingTargetScript;
        }(egs.Behaviour));
        scripts.RangingTargetScript = RangingTargetScript;
        egret.registerClass(RangingTargetScript,'egs.scripts.RangingTargetScript');
        var RangingDistanceScript = (function (_super) {
            __extends(RangingDistanceScript, _super);
            function RangingDistanceScript(target) {
                _super.call(this);
                this.Target = null;
                this.Distance = 0;
                this.Target = target;
            }
            var d = __define,c=RangingDistanceScript,p=c.prototype;
            p.onUpdate = function (dt) {
                var obj = this.Owner;
                if (obj != null && this.Target != null) {
                    this.Distance = egret.Point.distance(new egret.Point(obj.x, obj.y), new egret.Point(this.Target.x, this.Target.y));
                }
            };
            return RangingDistanceScript;
        }(egs.Behaviour));
        scripts.RangingDistanceScript = RangingDistanceScript;
        egret.registerClass(RangingDistanceScript,'egs.scripts.RangingDistanceScript');
        var RangingAngleScript = (function (_super) {
            __extends(RangingAngleScript, _super);
            function RangingAngleScript(target) {
                _super.call(this);
                this.Target = null;
                this.Angle = 0;
                this.Target = target;
            }
            var d = __define,c=RangingAngleScript,p=c.prototype;
            p.onUpdate = function (dt) {
                var obj = this.Owner;
                if (obj != null && this.Target != null) {
                    var tx = this.Target.x - obj.x;
                    var ty = this.Target.y - obj.y;
                    this.Angle = Math.atan2(ty, tx) * 180 / Math.PI + 180;
                }
            };
            return RangingAngleScript;
        }(egs.Behaviour));
        scripts.RangingAngleScript = RangingAngleScript;
        egret.registerClass(RangingAngleScript,'egs.scripts.RangingAngleScript');
        var RangingVectorScript = (function (_super) {
            __extends(RangingVectorScript, _super);
            function RangingVectorScript(target) {
                _super.call(this);
                this.Target = null;
                this.Target = target;
            }
            var d = __define,c=RangingVectorScript,p=c.prototype;
            p.onUpdate = function (dt) {
                var obj = this.Owner;
                if (obj != null && this.Target != null) {
                    var tx = this.Target.x - obj.x;
                    var ty = this.Target.y - obj.y;
                    var pt = new egret.Point(tx, ty);
                    pt.normalize(1);
                    this.Vector = pt;
                }
            };
            return RangingVectorScript;
        }(egs.Behaviour));
        scripts.RangingVectorScript = RangingVectorScript;
        egret.registerClass(RangingVectorScript,'egs.scripts.RangingVectorScript');
    })(scripts = egs.scripts || (egs.scripts = {}));
})(egs || (egs = {}));
